# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
include:
  - project: $BUILD_TEMPLATES_DIRECTORY
    file: $BUILD_FILE
    rules:
      - if: $CI_SERVER_URL == "https://gitlab.com"
        when: never
      - when: always
  - template: Security/SAST.gitlab-ci.yml
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - template: Security/Container-Scanning.gitlab-ci.yml
  - template: Jobs/Secret-Detection.gitlab-ci.yml

variables:
  DOCKERFILE: Dockerfile
  DOCKER_TAG: 1.12.4-2
  IMAGE_NAME: 'osdbk-admin-console'
  #gitlab security
  SAST_EXCLUDED_PATHS: spec,test,tests,tmp,target
#  SECURE_LOG_LEVEL: "debug"
  CS_IMAGE: registry.gitlab.com/logius/beveiligd-koppelvlak-extern/osdbk-admin-console:$DOCKER_TAG

stages:
  - npm_build                   #shared
  - docker_build                #shared
  - test                        #shared

npm_build:
  stage: npm_build
  image: node:16-alpine3.18
  script:
    - 'npm install --package-lock'
    - 'npm run build'
  rules:
    - if: $CI_SERVER_URL == "https://gitlab.com"
  artifacts:
    paths:
      - ./config/nginx.conf
      - dist/
    expire_in: 60 minutes

docker_build:
  stage: docker_build
  image: docker:20.10.11-dind
  services:
    - name: docker:20.10.11-dind
      alias: docker
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  script:
    - docker build --pull -t $CS_IMAGE .
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker push $CS_IMAGE
  rules:
    - if: $CI_SERVER_URL == "https://gitlab.com"

sast:
  stage: test
  allow_failure: true

dependency_scanning:
  before_script:
    - echo $MAVEN_SETTINGS > settings-lpc.xml
